
#property copyright " 2005-2008 BJF Trading Group"
#property link      "www.iticsoftware.com"
#property show_inputs

#define major   2
#define minor   3

//-----------------------------------------------------------------------------

extern string _tmp1_ = " --- Main settings ---";
extern string ClassName = "F5AC-11DB-BBA8";
extern int Timer = 1000;
extern bool LogLevel1 = true;
extern bool LogLevel2 = false;

extern string _tmp2_ = " --- Lot section ---";
extern string LotType_usage = "0: fixed; 1: scalable; 2: custom";
extern int LotType = 0;
extern double FixedLot = 1.0;
extern double kLot = 2.0;
extern int LotDigits = 1;

extern string _tmp3_ = " --- Trade params ---";
extern int MaxPriceDiff = 15;
extern bool AbsoluteStops = true;
extern bool DeferredStops = false;
extern int RepeatN = 3;
extern int Slippage = 3;

extern string _tmp4_ = " --- Labels ---";
extern int Timer.Corner = 1;
extern int Timer.X = 20;
extern int Timer.Y = 20;
extern string Timer.FontName = "Arial Narrow";
extern int Timer.FontSize = 24;
extern color Timer.FontColor = Gold;

extern int Error.Corner = 1;
extern int Error.X = 20;
extern int Error.Y = 60;
extern string Error.FontName = "Arial Narrow";
extern int Error.FontSize = 18;
extern color Error.FontColor = Red;

extern int About.Corner = 3;
extern int About.X = 20;
extern int About.Y = 15;
extern int About.dY = 16;
extern string About.FontName = "Verdana";
extern int About.FontSize = 10;
extern color About.FontColor = Silver;

//-----------------------------------------------------------------------------

#include <stdlib.mqh>
#include <stderror.mqh>

#import "user32.dll"
  int GetParent(int hWnd);
#import

#import "mtfx_s.dll"
  int _find_window(string class);

  int _init(int hTerminal, int hChart);
  int _deinit(int hTerminal, int hChart);
  int _marker_send(int hTerminal, int hChart);

  int _m_get_crc();
  int _m_image_get(int hTerminal);
  
  int _get_crc();
  
  bool _image_split();
  int _images_total();
  bool _image_select(int index);
  int _orders_total(int mode);
  bool _order_select(int pos, int mode);
  
  bool _order_get(
    int& ticket[], 
    int& open_time[], 
    int& type[], 
    double& lots[], 
    string& symbol[], 
    double& open_price[], 
    double& sl[], 
    double& tp[], 
    int& close_time[], 
    double& close_price[],
    datetime& expiration[],
    int& magic[], 
    string& comment[]);

#import

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix = "s-mtfx_s_";

int LastCRC = 0;
int LastTickCount = 0;
int hTerminal = 0;
int hChart = 0;
int marker_ret_code;

int m_ticket[1];
int m_open_time[1];
int m_type[1];
double m_lots[1];
string m_symbol[1];
double m_open_price[1];
double m_sl[1];
double m_tp[1];
int m_close_time[1];
double m_close_price[1];
datetime m_expiration[1];
int m_magic[1];
string m_comment[1];

void init()
{
  clear();

  hTerminal = TerminalHandle();
  hChart = WindowHandle(Symbol(), 0);
  
  _init(hTerminal, hChart);

  //-----
  
  m_symbol[0] = "";
  m_comment[0] = "";

  //64 bytes
  for (int i=0; i < 8; i++)
    m_symbol[0] = m_symbol[0] + "12345678";
  
  //256 bytes
  for (i=0; i < 32; i++)
    m_comment[0] = m_comment[0] + "12345678";

  //-----
    
  //warnings off
  if (false)
  {
    MapSymbols("");
    CustomLot("", 0.1);
    CustomMaxPriceDiff("");
  }
}

void deinit() 
{
  _deinit(hTerminal, hChart);
  
  clear();
  Comment("");
}

void start() 
{
  if (hTerminal == 0)
  {
    Alert("Terminal handle = 0");
    return;
  }

  if (hChart == 0)
  {
    Alert("Chart handle = 0");
    return;
  }

  while (!IsStopped())
  {
    string msg = TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
    Timer.TextOut(msg);
    
    About.TextOut();
    WindowRedraw();
      
    int res = main();
    if (res > 0) break;

    Sleep(Timer);
  }
}

int main()
{
  Error.TextOut("");

  int ret = _find_window(ClassName);
  if (ret == 0) 
  {
    Error.TextOut("Cannot find MultiTrade-Fx window");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }

  if (MathAbs(GetTickCount() - LastTickCount) >= 10*1000)
  {
    marker_ret_code = _marker_send(hTerminal, hChart);
    LastTickCount = GetTickCount();
  }

  if (marker_ret_code == 1)
  {
    //Error.TextOut("Active copy of the script found");
    //WindowRedraw();
    Alert("Active copy of the script found");
    return (1);
  }

  int i, j;
  int ticket, digits;
  double point;
  string symbol, msg;
    
  int m_crc = _m_get_crc();
  if (LastCRC != m_crc)
  {
    _m_image_get(hTerminal);
    _image_split();

    int images = _images_total();
    //Comment(images);
    
    for (i=0; i < images; i++)
    {
      if (!_image_select(i)) continue;
      
      int orders = _orders_total(MODE_HISTORY);
      for (j=0; j < orders; j++)
      {
        if (!_order_select(j, MODE_HISTORY)) continue;
        
        _order_get(
          m_ticket,
          m_open_time,
          m_type,
          m_lots,
          m_symbol,
          m_open_price,
          m_sl,
          m_tp,
          m_close_time,
          m_close_price,
          m_expiration,
          m_magic,
          m_comment);
          
        msg = StringConcatenate(
          "H: ticket ", m_ticket[0],
          "; open_time: ", TimeToStr(m_open_time[0]),
          "; type: ", OrdT2Str(m_type[0]),
          "; lots: ", m_lots[0],
          "; symbol: ", symbol,
          "; open_price: ", m_open_price[0],
          "; sl: ", m_sl[0],
          "; tp: ", m_tp[0],
          "; close_time: ", TimeToStr(m_close_time[0]),
          "; close_price: ", m_close_price[0],
          "; expir.: ", m_expiration[0],
          "; magic: ", m_magic[0],
          "; comment: ", m_comment[0]);
        WriteLog2(msg);
          
        symbol = MapSymbols(m_symbol[0]);
        digits = MarketInfo(symbol, MODE_DIGITS);
        point = MarketInfo(symbol, MODE_POINT);
        
        if (point == 0)
        {
          msg = "[Main] Does \"" +symbol+ "\" symbol present in the MarketWatch window?";
          WriteLog1(msg);
          continue;
        }

        m_open_price[0] = NormalizeDouble(m_open_price[0], digits);
        m_close_price[0] = NormalizeDouble(m_close_price[0], digits);
        m_sl[0] = NormalizeDouble(m_sl[0], digits);
        m_tp[0] = NormalizeDouble(m_tp[0], digits);
       
        ticket = GetOrderByMagic(m_ticket[0], MODE_TRADES);
        if (ticket > 0) KillOrder();
      }
      
      //-----
      
      orders = _orders_total(MODE_TRADES);
      for (j=0; j < orders; j++)
      {
        if (!_order_select(j, MODE_TRADES)) continue;
        
        _order_get(
          m_ticket,
          m_open_time,
          m_type,
          m_lots,
          m_symbol,
          m_open_price,
          m_sl,
          m_tp,
          m_close_time,
          m_close_price,
          m_expiration,
          m_magic,
          m_comment);

        msg = StringConcatenate(
          "T: ticket ", m_ticket[0],
          "; open_time: ", TimeToStr(m_open_time[0]),
          "; type: ", OrdT2Str(m_type[0]),
          "; lots: ", m_lots[0],
          "; symbol: ", symbol,
          "; open_price: ", m_open_price[0],
          "; sl: ", m_sl[0],
          "; tp: ", m_tp[0],
          "; close_time: ", TimeToStr(m_close_time[0]),
          "; close_price: ", m_close_price[0],
          "; expir.: ", m_expiration[0],
          "; magic: ", m_magic[0],
          "; comment: ", m_comment[0]);
        WriteLog2(msg);

        symbol = MapSymbols(m_symbol[0]);
        digits = MarketInfo(symbol, MODE_DIGITS);
        point = MarketInfo(symbol, MODE_POINT);
        
        if (point == 0)
        {
          msg = "[Main] Does " +symbol+ " present in the MarketWatch window?";
          WriteLog1(msg);
          continue;
        }
        
        //partial close
        if (StringFind(m_comment[0], "from #") != -1) continue;
          
        m_open_price[0] = NormalizeDouble(m_open_price[0], digits);
        m_close_price[0] = NormalizeDouble(m_close_price[0], digits);
        m_sl[0] = NormalizeDouble(m_sl[0], digits);
        m_tp[0] = NormalizeDouble(m_tp[0], digits);
        
        ticket = GetOrderByMagic(m_ticket[0], MODE_HISTORY);
        if (ticket > 0)
        {
          WriteLog1("[main] Ticket #" +m_ticket[0]+ " found in the history, no action");
          continue;
        }
        
        ticket = GetOrderByMagic(m_ticket[0], MODE_TRADES);
          
        if (ticket == -1)
        {
          SetOrder();
        }
        else
        {
          if (m_open_price[0] != NormalizeDouble(OrderOpenPrice(), digits) || 
              m_sl[0] != NormalizeDouble(OrderStopLoss(), digits) ||
              m_tp[0] != NormalizeDouble(OrderTakeProfit(), digits))
          {
            ModifyOrder();
          }
        }
      }      
    }
    
    LastCRC = m_crc;
  }
  
//Comment(m_crc, "  ", _get_crc());  

  return (0);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void WriteLog1(string msg)
{
  if (!LogLevel1) return;
  
  Print(msg);
}

void WriteLog2(string msg)
{
  if (!LogLevel2) return;
  
  Print(msg);
}

int GetOrderByMagic(int magic, int mode)
{
  int cnt = 0;  
  if (mode == MODE_TRADES) cnt = OrdersTotal();
  if (mode == MODE_HISTORY) cnt = OrdersHistoryTotal();
  
  for (int i=0; i<cnt; i++)
  {
    if (!OrderSelect(i, SELECT_BY_POS, mode)) continue;
    
    if (OrderMagicNumber() == magic) return (OrderTicket());
  }
  
  return (-1);
}

double GetLot()
{
  double lot = FixedLot;
  
  if (LotType == 0)
  {
    lot = FixedLot;
  }
  
  else if (LotType == 1) 
  {
    lot = kLot*m_lots[0];
  }
  
  else if (LotType == 2)
  {
    string symbol = MapSymbols(m_symbol[0]);
    lot = CustomLot(symbol, m_lots[0]);
  }

  lot = NormalizeDouble(lot, LotDigits);    
  if (lot <= 0)
  {
    if (LotDigits == 1) 
      lot = 0.1;
    else if (LotDigits == 2) 
      lot = 0.01;
    else
      lot = 0.1;
  }
  
  return (lot); 
}

int SetOrder()
{
  int digits, ticket;
  double bid, ask, point, sl, tp;
  string msg;
  
  string symbol = MapSymbols(m_symbol[0]);
  int max_price_diff = CustomMaxPriceDiff(symbol);
  int type = m_type[0];
  
  point = MarketInfo(symbol, MODE_POINT);
  digits = MarketInfo(symbol, MODE_DIGITS);

  if (type == OP_BUY) 
  {
    for (int i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);  

      if (MathAbs(m_open_price[0] - ask) > max_price_diff*point) 
      {
        int price_diff = MathRound(MathAbs(m_open_price[0]-ask)/point);
        msg = StringConcatenate(
          "[SetOrder] MaxPriceDiff filter triggered: ",
          " symbol: ", symbol,
          "; master_open_price: ", DoubleToStr(m_open_price[0], digits),
          "; actual_open_price: ", DoubleToStr(ask, digits),
          "; price_diff: ", price_diff, " pips",
          "; max_price_diff: ", max_price_diff, " pips");
        
        WriteLog1(msg);
        return (false);
      }

      sl = 0.0;
      tp = 0.0;
      
      if (AbsoluteStops)
      {
        sl = m_sl[0];
        tp = m_tp[0];
      }
      else
      {
        if (m_sl[0] > 0) sl = ask - (m_open_price[0] - m_sl[0]);
        if (m_tp[0] > 0) tp = ask + (m_tp[0] - m_open_price[0]);
      }
  
      if (DeferredStops)
      {
        ticket = Buy(symbol, GetLot(), ask, 0, 0, m_ticket[0], m_comment[0]);
        
        if (sl > 0 || tp > 0)
        {
          OrderSelect(ticket, SELECT_BY_TICKET);
          OrderModify(ticket, OrderOpenPrice(), sl, tp, 0);
        }
      
        if (ticket > 0) break;
      }
      else
      {
        ticket = Buy(symbol, GetLot(), ask, sl, tp, m_ticket[0], m_comment[0]);
        if (ticket > 0) break;
      }
    }
    
    return (ticket > 0);
  }

  //-----

  if (type == OP_SELL) 
  {
    for (i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);  

      if (MathAbs(m_open_price[0] - bid) > max_price_diff*point) 
      {
        price_diff = MathRound(MathAbs(m_open_price[0]-bid)/point);
        msg = StringConcatenate(
          "[SetOrder] MaxPriceDiff filter triggered: ",
          " symbol: ", symbol,
          "; master_open_price: ", DoubleToStr(m_open_price[0], digits),
          "; actual_open_price: ", DoubleToStr(bid, digits),
          "; price_diff: ", price_diff, " pips",
          "; max_price_diff: ", max_price_diff, " pips");
      
        WriteLog1(msg);
        return (false);
      }

      sl = 0.0;
      tp = 0.0;

      if (AbsoluteStops)
      {
        sl = m_sl[0];
        tp = m_tp[0];
      }
      else
      {
        if (m_sl[0] > 0) sl = bid + (m_sl[0] - m_open_price[0]);
        if (m_tp[0] > 0) tp = bid - (m_open_price[0] - m_tp[0]);
      }
  
      if (DeferredStops)
      {
        ticket = Sell(symbol, GetLot(), bid, 0, 0, m_ticket[0], m_comment[0]);
        
        if (sl > 0 || tp > 0)
        {
          OrderSelect(ticket, SELECT_BY_TICKET);
          OrderModify(ticket, OrderOpenPrice(), sl, tp, 0);
        }
      
        if (ticket > 0) break;
      }
      else
      {
        ticket = Sell(symbol, GetLot(), bid, sl, tp, m_ticket[0], m_comment[0]);
        if (ticket > 0) break;
      }
    }
    
    return (ticket > 0);
  }

  //-----
      
  if (type == OP_BUYSTOP)
  {
    for (i=0; i < RepeatN; i++)
    {
      ticket = SetBuyStop(symbol, GetLot(), m_open_price[0], m_sl[0], m_tp[0], m_ticket[0], m_comment[0]);
      if (ticket > 0) break;
    }
    
    return (ticket > 0);
  }

  //-----

  if (type == OP_SELLSTOP)
  {
    for (i=0; i < RepeatN; i++)
    {
      ticket = SetSellStop(symbol, GetLot(), m_open_price[0], m_sl[0], m_tp[0], m_ticket[0], m_comment[0]);
      if (ticket > 0) break;
    }
    
    return (ticket > 0);
  }
  
  //-----
  
  if (type == OP_BUYLIMIT)
  {
    for (i=0; i < RepeatN; i++)
    {
      ticket = SetBuyLimit(symbol, GetLot(), m_open_price[0], m_sl[0], m_tp[0], m_ticket[0], m_comment[0]);
      if (ticket > 0) break;
    }
    
    return (ticket > 0);
  }
  
  //-----
  
  if (type == OP_SELLLIMIT)
  {
    for (i=0; i < RepeatN; i++)
    {
      ticket = SetSellLimit(symbol, GetLot(), m_open_price[0], m_sl[0], m_tp[0], m_ticket[0], m_comment[0]);
      if (ticket > 0) break;
    }
    
    return (ticket > 0);
  }
  
  return (false);
}

int ModifyOrder()
{
  double sl, tp;
  int type = m_type[0];
  
  if (type == OP_BUY)
  {
    if (AbsoluteStops)
    {
      sl = m_sl[0];
      tp = m_tp[0];
    }
    else
    {
      sl = OrderOpenPrice() - (m_open_price[0] - m_sl[0]);
      tp = OrderOpenPrice() + (m_tp[0] - m_open_price[0]);
    }

    for (int i=0; i < RepeatN; i++)
    {  
      bool res = OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0);
      if (res) break;
    }
    
    return (res);
  }

  if (type == OP_SELL)
  {
    if (AbsoluteStops)
    {
      sl = m_sl[0];
      tp = m_tp[0];
    }
    else
    {
      sl = OrderOpenPrice() + (m_sl[0] - m_open_price[0]);
      tp = OrderOpenPrice() - (m_open_price[0] - m_tp[0]);
    }

    for (i=0; i < RepeatN; i++)
    {
      res = OrderModify(OrderTicket(), OrderOpenPrice(), m_sl[0], m_tp[0], 0);
      if (res) break;
    }
    
    return (res);
  }

  if (type == OP_BUYSTOP || type == OP_SELLSTOP || type == OP_BUYLIMIT || type == OP_SELLLIMIT)
  {
    res = OrderModify(OrderTicket(), m_open_price[0], m_sl[0], m_tp[0], 0);   
    return (res);
  }  
  
  return (false);
}

int KillOrder()
{
  double bid, ask, lot;
  string msg;
  
  string symbol = MapSymbols(m_symbol[0]);
  int type = m_type[0];
      
  if (type == OP_BUY) 
  {
    for (int i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);
    
      lot = GetLot();
      if (lot > OrderLots()) lot = OrderLots();
      
      bool res = CloseOrder(OrderTicket(), lot, bid);
      if (res) break;  
    }
    
    return (res);
  }

  //-----
  
  if (type == OP_SELL) 
  {
    for (i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);

      lot = GetLot();
      if (lot > OrderLots()) lot = OrderLots();
    
      res = CloseOrder(OrderTicket(), lot, ask);
      if (res) break;
    }
    
    return (res);
  }
  
  //-----
  
  if (type == OP_BUYSTOP || type == OP_SELLSTOP || type == OP_BUYLIMIT || type == OP_SELLLIMIT)
  {
    for (i=0; i < RepeatN; i++)
    {
      res = DeleteOrder(OrderTicket());
      if (res) break;
    }
    
    return (res);
  }

  return (false);
}

string OrdT2Str(int type) 
{
  switch (type)
  {
    case OP_BUY:        return ("Buy"); 
    case OP_SELL:       return ("Sell");
    case OP_BUYLIMIT:   return ("BuyLimit");
    case OP_SELLLIMIT:  return ("SellLimit");
    case OP_BUYSTOP:    return ("BuyStop");
    case OP_SELLSTOP:   return ("SellStop");
    default:            return (type);
  }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 1000;
int SleepErr = 5000;

int Buy(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Buy \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  int res = OrderSend(symbol, OP_BUY, lot, price, Slippage, sl, tp, comment, magic, 0);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int Sell(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Sell \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELL, lot, price, Slippage, sl, tp, comment, magic, 0);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening SELL order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetBuyLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_BUYLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetBuyStop(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyStop \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_BUYSTOP, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYSTOP order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellStop(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellStop \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLSTOP, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLSTOP order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price) 
{
  if (!OrderSelect(ticket, SELECT_BY_TICKET)) return(false);
  if (OrderCloseTime() > 0) return(false);
  
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", Slippage);
  
  bool res = OrderClose(ticket, lot, price, Slippage);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

bool DeleteOrder(int ticket) 
{
  Print("DeleteOrder ", ticket);
  
  bool res = OrderDelete(ticket);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("DeleteOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int TerminalHandle()
{
  int hWnd = WindowHandle(Symbol(), Period());
  int hParent = 0;
  
  while (!IsStopped()) 
  {
    hWnd = GetParent(hWnd);
    if (hWnd == 0) break;
    hParent = hWnd;
  }
  
  return (hParent);
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
  
  WindowRedraw();
  Comment("");
}


void Timer.TextOut(string txt)
{
  string obj_name = prefix + "timer";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Timer.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Timer.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Timer.Corner);

  ObjectSetText(obj_name, txt, Timer.FontSize, Timer.FontName, Timer.FontColor);
}

void Error.TextOut(string txt)
{
  string obj_name = prefix + "err";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Error.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Error.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Error.Corner);

  ObjectSetText(obj_name, txt, Error.FontSize, Error.FontName, Error.FontColor);
}

void About.TextOut()
{  
  string obj_name = prefix + "about1";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  ObjectSetText(obj_name, "www.e2e-fx.net", About.FontSize, About.FontName, About.FontColor);

  //-----
  
  obj_name = prefix + "about2";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  ObjectSetText(obj_name, " 2005-2008 RickD", About.FontSize, About.FontName, About.FontColor);

  //-----
  
  obj_name = prefix + "about3";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+2*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  ObjectSetText(obj_name, "MT-Fx Slave Script", About.FontSize, About.FontName, About.FontColor);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string MapSymbols(string sym)
{
  //if (sym == "EURUSD") return ("mEURUSD");
  //if (sym == "GBPUSD") return ("mGBPUSD");
 
  return (sym);
}

double CustomLot(string sym, double master_lot)
{
  // double lot = 0.1 * AccountEquity() / 1000.0;
  // lot = NormalizeDouble(lot, 1);
  // return (lot);
  
  return (FixedLot);
}

int CustomMaxPriceDiff(string sym)
{
  //if (sym == "EURUSD") return (50);
  //if (sym == "GBPUSD") return (100);
 
  return (MaxPriceDiff);
}